#include "test.h"
#include <QDebug>
Test::Test(QObject *parent) : QObject(parent)
{
    mStatCpu =    new SysStat::CpuStat(this);
    mStatMemory = new SysStat::MemStat(this);
    mStatNet = new SysStat::NetStat(this);

}

void Test::testCpu()
{
    for(QString q : mStatCpu->sources()) {
    SysStat::BaseStat *b = new SysStat::CpuStat(this);
    b->setMonitoredSource(q);
    qobject_cast<SysStat::CpuStat*>(b)->setMonitoring(SysStat::CpuStat::LoadAndFrequency);
    connect(qobject_cast<SysStat::CpuStat*>(b), SIGNAL(update(float, float, float, float, float, uint)), this, SLOT(cpuUpdate(float, float, float, float, float, uint)));
    b->setUpdateInterval(1000.0);
    }

}

void Test::testMemory()
{
    mStatMemory = new SysStat::MemStat(this);
    mStatSwap = new SysStat::MemStat(this);
    mStatMemory->setMonitoredSource("memory");
    mStatSwap->setMonitoredSource("swap");
    connect(qobject_cast<SysStat::MemStat*>(mStatSwap), SIGNAL(swapUpdate(float)), this, SLOT(swapUpdate(float)));
    connect(qobject_cast<SysStat::MemStat*>(mStatMemory), SIGNAL(memoryUpdate(float, float, float)), this, SLOT(memoryUpdate(float, float, float)));
    mStatSwap->setUpdateInterval(1000.0);
    mStatMemory->setUpdateInterval(1000.0);
}
void Test::testNet()
{
    mStatNet = new SysStat::NetStat(this);
    for(QString q : mStatNet->sources()) {
        SysStat::BaseStat *b = new SysStat::NetStat(this);
        b->setMonitoredSource(q);
        connect(qobject_cast<SysStat::NetStat*>(b), SIGNAL(update(unsigned,unsigned)), this, SLOT(networkUpdate(unsigned,unsigned)));
        b->setUpdateInterval(1000.0);

    }
}
void Test::cpuUpdate(float user, float nice, float system, float other, float frequencyRate, uint) {
    SysStat::BaseStat *source = qobject_cast<SysStat::BaseStat*>(sender());

    qDebug() << source->monitoredSource() << "User:" << user*100.00;
    qDebug() << source->monitoredSource() << "nice:" << nice*100.00;
    qDebug() << source->monitoredSource() << "system:" << system*100.00;
    qDebug() << source->monitoredSource() << "other:" << other*100.00;
    qDebug() << source->monitoredSource() << "frequencyrate:" << frequencyRate*100.00;
}
void Test::memoryUpdate(float apps, float buffers, float cached)
{
qDebug() << "memory" << "apps:" << apps*100.00 << "buffers"<< buffers*100.0 << "cached" << cached;
}
void Test::swapUpdate(float used)
{
    qDebug() << "swap" << used*100.00;
}
void Test::networkUpdate(unsigned received, unsigned transmitted)
{
    SysStat::BaseStat *source = qobject_cast<SysStat::BaseStat*>(sender());
    qDebug() << source->monitoredSource() << "receivecd" << received << "transmitted" << transmitted;
}
int main(int argc, char* argv[])
{
    QScopedPointer<QCoreApplication> app(new QCoreApplication(argc, argv));
    Test *t = new Test();
    t->testCpu();
    t->testMemory();
    t->testNet();
    return app->exec();
}
