#ifndef TEST_H
#define TEST_H

#include <QObject>
#include <QCoreApplication>
#include <SysStat/CpuStat>
#include <SysStat/MemStat>
#include <SysStat/NetStat>
class Test : public QObject
{
    Q_OBJECT
public:
    explicit Test(QObject *parent = nullptr);

private:
    SysStat::BaseStat *mStatCpu;
    SysStat::BaseStat *mStatNet;
    SysStat::BaseStat *mStatMemory;
    SysStat::BaseStat *mStatSwap;
public:
    void testCpu();
    void testMemory();
    void testNet();
signals:

public slots:
    void cpuUpdate(float user, float nice, float system, float other, float frequencyRate, uint);
    void memoryUpdate(float apps, float buffers, float cached);
    void swapUpdate(float used);
    void networkUpdate(unsigned received, unsigned transmitted);
};

#endif // TEST_H
